! Module   : gyre_c_state
! Purpose  : mutable state data for solvers (complex)
!
! Copyright 2017-2018 Rich Townsend
!
! This file is part of GYRE. GYRE is free software: you can
! redistribute it and/or modify it under the terms of the GNU General
! Public License as published by the Free Software Foundation, version 3.
!
! GYRE is distributed in the hope that it will be useful, but WITHOUT
! ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
! or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
! License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

$include 'core.inc'

module gyre_c_state

  ! Uses

  use core_kinds

  ! No implicit typing

  implicit none

  ! Derived-type definitions

  type :: c_state_t
     complex(WP) :: omega = 0._WP
     real(WP)    :: omega_r = 0._WP
  end type c_state_t

  ! Access specifiers

  private

  public :: c_state_t

end module gyre_c_state
